# SoSphere Class Reference
[Nodes]

`#include <Inventor/nodes/SoSphere.h>`

Inheritance diagram for SoSphere:

List of all members.

## Detailed Description

The SoSphere class is for rendering sphere shapes.

Renders a sphere with the size given by the SoSphere::radius field. The sphere is rendered with the current material, texture and drawstyle settings (if any, otherwise the default settings are used).

The SoSphere node class is provided as a convenient abstraction for the application programmer to use "complex" shapes of this type without having to do the tessellation to polygons and other low-level programming herself.

A good trick for rendering ellipsoidal 3D shapes is to use an SoSphere prefixed with an SoScale transformation to "flatten" it along one or more of the principal axes. (Ie use for instance an SoScale node with SoScale::scaleFactor equal to [1, 1, 0.1] to flatten it along the Z direction.)

A sphere is visualized by the underlying rendering system by first tessellating the conceptual sphere into a set of polygons. To control the trade-off between an as much as possible correct visual appearance of the sphere versus fast rendering, use an SoComplexity node to influence the number of polygons generated from the tessellation process. (The higher the complexity value, the more polygons will be generated, the more rounded the sphere will look.) Set the SoComplexity::value field to what you believe would be a good trade-off between correctness and speed for your particular application.

See also:
  SoCone, SoCylinder, SoCube

## Public Member Functions

| SoSphere (void)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFFloat | radius

## Protected Member Functions

virtual | ~SoSphere ()
virtual void | generatePrimitives (SoAction *action)
virtual void | computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)

## Constructor & Destructor Documentation

SoSphere::SoSphere | ( | void |  | ) |

| Constructor.

SoSphere::~SoSphere | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoSphere::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoShape.

void SoSphere::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoShape.

void SoSphere::rayPick | ( | SoRayPickAction * | action | ) | `[virtual]`

| Calculates picked point based on primitives generated by subclasses. Reimplemented from SoShape.

void SoSphere::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoShape.

void SoSphere::generatePrimitives | ( | SoAction * | action | ) | `[protected, virtual]`

The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().)

The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller.

Implements SoShape.

void SoSphere::computeBBox | ( | SoAction * | action,
|  | SbBox3f & | box,
|  | SbVec3f & | center
| ) | `[protected, virtual]`

Implemented by SoShape subclasses to let the SoShape superclass know the exact size and weighted center point of the shape's bounding box.

The bounding box and center point should be calculated and returned in the local coordinate system.

The method implements action behavior for shape nodes for SoGetBoundingBoxAction. It is invoked from SoShape::getBoundingBox(). (Subclasses should not override SoNode::getBoundingBox().)

The box parameter sent in is guaranteed to be an empty box, while center is undefined upon function entry.

Implements SoShape.

## Member Data Documentation

SoSFFloat SoSphere::radius

| Radius of sphere. Default value is 1.0.

The documentation for this class was generated from the following files:

- SoSphere.h
- SoSphere.cpp